/**
 *
 */
package jp.agentec.sinaburocast.csv;

import jp.agentec.sinaburocast.entity.Member;
import jp.agentec.sinaburocast.service.MemberService;

import org.seasar.framework.util.StringUtil;
import org.seasar.s2csv.csv.annotation.CSVValidator;
import org.seasar.s2csv.csv.annotation.column.CSVColumn;
import org.seasar.s2csv.csv.annotation.entity.CSVEntity;

/**
 * @author kim-hs
 *
 */
@CSVEntity(header=true,demiliter='\t',headerCheck=false,columnCountCheck=false)
public class DeliveryGroupInfoCsv extends AbstractCsv {

	public MemberService memberService;

	@CSVValidator(msgKey = "errors.memberId", method = "validateMemberId")
	@CSVColumn(columnIndex = 0, columnName = "会員ID")
	public String memberId;

	@CSVColumn(columnIndex = 1, columnName = "結果")
	public String okNg = "OK";

	@CSVColumn(columnIndex = 2, columnName = "理由")
	public String reason = "reason";

	public boolean validateMemberId(String args) {

		Member memberInfo = null;

		if(StringUtil.isBlank(args)) return false;

		memberInfo = memberService.findByDeleteId(Integer.parseInt(args));

		if (memberInfo != null) {
			return true;
		}
		return false;
	}
}
